package javapas;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.beans.*;

/**
 * <p>Title: Javapas</p>
 * <p>Description: Pascal Interpreter</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: AP</p>
 *
 * Interfejs graficzny aplikacji
 *
 * @author Wojciech Nabiaek
 * @version 1.0
 */

public class API extends JFrame {
  private JPanel contentPane;

  private ImageIcon otworz = new ImageIcon("src/img/Fileopen.gif");
  private ImageIcon nowy = new ImageIcon("src/img/Filenew.gif");
  private ImageIcon zapisz = new ImageIcon("src/img/Filesave.gif");
  private ImageIcon wyjdz = new ImageIcon("src/img/Exit.gif");
  private ImageIcon sprawdz = new ImageIcon("src/img/Check.gif");
  private ImageIcon uruchom = new ImageIcon("src/img/Gears.gif");

  private JMenuBar jMenuBar1 = new JMenuBar();
  private JMenu jMenu1 = new JMenu();
  private JMenuItem jMenuItem8 = new JMenuItem("Nowy plik", nowy);
  private JMenuItem jMenuItem1 = new JMenuItem("Otwrz", otworz);
  private JMenuItem jMenuItem2 = new JMenuItem("Zapisz", zapisz);
  private JMenuItem jMenuItem3 = new JMenuItem("Koniec", wyjdz);
  private JMenu jMenu2 = new JMenu();
  private JMenuItem jMenuItem4 = new JMenuItem("Sprawd bdy", sprawdz);
  private JMenuItem jMenuItem5 = new JMenuItem("Wykonaj program", uruchom);
  private JMenuItem jMenuItem9 = new JMenuItem();
  private JMenu jMenu3 = new JMenu();
  private JMenuItem jMenuItem6 = new JMenuItem();
  private JMenuItem jMenuItem7 = new JMenuItem();

  private GridLayout gridLayout1 = new GridLayout();
  private JSplitPane jSplitPane1 = new JSplitPane();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JScrollPane jScrollPane2 = new JScrollPane();
  private JTextArea jEditorPane1 = new JTextArea();
  private JTextArea jEditorPane2 = new JTextArea();
  private JPanel panel = new JPanel();

  private File file		= new File("nowy.pas");

  private String openPrompt	= new String("Otwrz plik");
  private String closePrompt	= new String("Zapisz plik jako");

  private Debug deb = new Debug();

  /**
   * Konstruktor domylny klasy
   */
  public API() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * Inicjalizacja interfejsu
   *
   * @throws Exception
   */
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    jMenuBar1.setToolTipText("");
    contentPane.setLayout(gridLayout1);
    this.setJMenuBar(jMenuBar1);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Pascal interpreter");
    jMenu1.setToolTipText("");
    jMenu1.setText("Plik");
    jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(113, 0, false));
    jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem1_actionPerformed(e);
      }
    });
    jMenuItem2.setActionCommand("Zapisz");
    jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(114, 0, false));
    jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem2_actionPerformed(e);
      }
    });
    jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem3_actionPerformed(e);
      }
    });
    jMenu2.setText("Uruchom");
    jMenuItem4.setAccelerator(javax.swing.KeyStroke.getKeyStroke(117, 0, false));
    jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem4_actionPerformed(e);
      }
    });
    jMenuItem5.setAccelerator(javax.swing.KeyStroke.getKeyStroke(120, 0, false));
    jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem5_actionPerformed(e);
      }
    });
    jMenu3.setText("Pomoc");
    jMenuItem6.setText("Autorzy");
    jMenuItem6.setAccelerator(javax.swing.KeyStroke.getKeyStroke(112, java.awt.event.KeyEvent.CTRL_MASK, false));
    jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem6_actionPerformed(e);
      }
    });
    jMenuItem7.setText("O programie");
    jMenuItem7.setAccelerator(javax.swing.KeyStroke.getKeyStroke(121, 0, false));
    jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem7_actionPerformed(e);
      }
    });
    jEditorPane1.setToolTipText("");
    jMenuItem8.setToolTipText("");
    jMenuItem8.setAccelerator(javax.swing.KeyStroke.getKeyStroke(112, 0, false));
    jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem8_actionPerformed(e);
      }
    });
//  sprawdza czy poprawnie zostaly zaladowane ikony do menu (dla wersji wykonywalnej i jar)
    if (jMenuItem1.getIcon().getIconHeight()==-1){
      try{
        jMenuItem1.setIcon(new ImageIcon(Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("/img/Fileopen.gif"))));
        jMenuItem2.setIcon(new ImageIcon(Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("/img/Filesave.gif"))));
        jMenuItem3.setIcon(new ImageIcon(Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("/img/Exit.gif"))));
        jMenuItem4.setIcon(new ImageIcon(Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("/img/Check.gif"))));
        jMenuItem5.setIcon(new ImageIcon(Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("/img/Gears.gif"))));
        jMenuItem8.setIcon(new ImageIcon(Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("/img/Filenew.gif"))));
      } catch (Exception e){}
    }
    jMenuItem3.setAccelerator(javax.swing.KeyStroke.getKeyStroke(115, java.awt.event.KeyEvent.ALT_MASK, false));
    jMenuItem9.setText("Zobacz pseudokod programu");
    jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem9_actionPerformed(e);
      }
    });
    jMenuBar1.add(jMenu1);
    jMenuBar1.add(jMenu2);
    jMenuBar1.add(jMenu3);
    jMenu1.add(jMenuItem8);
    jMenu1.add(jMenuItem1);
    jMenu1.add(jMenuItem2);
    jMenu1.addSeparator();
    jMenu1.add(jMenuItem3);
    jMenu2.add(jMenuItem4);
    jMenu2.add(jMenuItem5);
    jMenu2.addSeparator();
    jMenu2.add(jMenuItem9);
    jMenu3.addSeparator();
    jMenu3.add(jMenuItem6);
    jMenu3.add(jMenuItem7);

    contentPane.add(jScrollPane1, null);
    jScrollPane1.getViewport().add(panel, null);
    panel.setLayout(new BorderLayout());
    panel.add(jSplitPane1, BorderLayout.CENTER);
    jSplitPane1.setLeftComponent(jEditorPane2);
    jSplitPane1.setRightComponent(jEditorPane1);
    jSplitPane1.setDividerSize(3);
    jSplitPane1.setDividerLocation(30);
    jEditorPane2.setEditable(false);
    jEditorPane1.addKeyListener(new KeyListener(){
      public void keyPressed(KeyEvent ev){}
      public void keyTyped(KeyEvent ev){};
      public void keyReleased(KeyEvent ev){
        int kl= ev.getKeyCode();
        if((kl==10)|| (kl==127)||(kl==8)||(kl==86)||(kl==88)) przenumerujLinie();
        if(kl==117) jMenuItem4_actionPerformed(null);
      };
    });
  }

  /**
   * Metoda przejmujca zdarzenie zamknicia okna.
   *
   * @param e typ zdarzenia
   */
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  /**
   * Metoda wywoywana po wcinicu guzika Koniec
   *
   * @param e typ zdarzenia
   */
  void jMenuItem3_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  /**
   * Metoda przenumerowuje linie w panelu z numeracj wierszy kodu
   */
  private void przenumerujLinie(){
    jEditorPane2.setText("");
    for(int i=0; i<jEditorPane1.getLineCount(); i++){
      jEditorPane2.append(""+(i+1)+"\r\n");
    }
  };

  /**
  * Metoda wywietla okno dialogu do operacji na plikach
  *
  * @param mode tryb otwarcia okna
  * @return <code>true</code> - jeli operacja powioda si, <code>false</code> w przeciwnym przypadku
  */
  private boolean getFile(int mode) {
    String prompt;
    String filename;
    String pathname;
    if (mode == FileDialog.LOAD) prompt = openPrompt;
    else prompt = closePrompt;
    FileDialog d = new FileDialog(this, prompt, mode);
    if (mode == FileDialog.LOAD) d.setFile("*");
    else d.setFile(file.getName());
    d.setDirectory(".");
    d.setVisible(true);
    filename = d.getFile();
    pathname = d.getDirectory() + filename;
    if (filename != null) {
      file = new File(pathname);
      return(true);
    } else return(false);
  }

  /**
   * Metoda wywoywana po wybraniu z menu opcji Otwrz plik
   *
   * @param e typ zdarzenia
   */
  void jMenuItem1_actionPerformed(ActionEvent e) {
    String part;
    StringBuffer all = new StringBuffer("");
    if (getFile(FileDialog.LOAD)) {
      try {
        FileReader fr = new FileReader(file);
        BufferedReader br=new BufferedReader(fr);
        while ( (part=br.readLine()) != null) {
          all.append(part);
          all.append('\n');
        }
        br.close();
        fr.close();
        jEditorPane1.setText(all.toString());
        jEditorPane1.setCaretPosition(0);
        przenumerujLinie();
      } catch (IOException ex) {
        ex.printStackTrace();
      }
    }
    repaint();
  }

  /**
   * Metoda wywoywana po wybraniu z menu opcji Zapisz plik
   *
   * @param e typ zdarzenia
   */
  void jMenuItem2_actionPerformed(ActionEvent e) {
    boolean ok;
    ok = getFile(FileDialog.SAVE);
    if (ok) {
      String all = jEditorPane1.getText();
      try {
        FileWriter fw = new FileWriter(file);
        BufferedWriter bw=new BufferedWriter(fw);
        bw.write(all,0,all.length());
        bw.close();
        fw.close();
      } catch (IOException ex) {
        ex.printStackTrace();
      }
    }
    repaint();
  }

  /**
   * Metoda wywoywana po wybraniu z menu opcji Informacja o autorach
   *
   * @param e typ zdarzenia
   */
  void jMenuItem6_actionPerformed(ActionEvent e) {
    Autorzy frame = new Autorzy();
    frame.validate();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  /**
   * Metoda wywoywana po wybraniu z menu opcji Wykonaj program
   *
   * @param e typ zdarzenia
   */
  void jMenuItem5_actionPerformed(ActionEvent e) {
//
// Sprawdzenie poprwanosci kodu
    Poprawiacz pop = new Poprawiacz();
    pop.jta_plik.setText(jEditorPane1.getText());
    String wy = pop.sprawdzanie();
    if (! wy.equalsIgnoreCase("File OK")) System.err.println(wy);
    else {

// Stworzenie 'kodu maszynowego'
      Prekompilator kod = new Prekompilator(jEditorPane1.getText());
      kod.run();

// Wykonanie programu
      VM interpreter = new VM(kod.Operacje(), kod.Zmienne());
    }
  }

  /**
   * Metoda wywoywana po wybraniu z menu opcji Nowy plik
   *
   * @param e typ zdarzenia
   */
  void jMenuItem8_actionPerformed(ActionEvent e) {
    jEditorPane1.setText("");
    jEditorPane2.setText("1");
  }

  /**
   * Metoda wywoywana po wybraniu z menu opcji Sprawd bdy
   *
   * @param e typ zdarzenia
   */
  void jMenuItem4_actionPerformed(ActionEvent e) {
    Poprawiacz pop = new Poprawiacz();
    pop.jta_plik.setText(jEditorPane1.getText());
    System.err.println(pop.sprawdzanie());
  }

  /**
   * Metoda wywoywana po wybraniu z menu opcji Zobacz pseudokod programu
   *
   * @param e typ zdarzenia
   */
  void jMenuItem9_actionPerformed(ActionEvent e) {
    Poprawiacz pop = new Poprawiacz();
    pop.jta_plik.setText(jEditorPane1.getText());
    String wy = pop.sprawdzanie();
    if (! wy.equalsIgnoreCase("File OK")) System.err.println(wy);
    else {
      Prekompilator kod = new Prekompilator(jEditorPane1.getText());
      kod.run();
      deb.setText(kod.Operacje());
      deb.setVisible(true);
    };
  }

  /**
   * Metoda wywoywana po wybraniu z menu opcji O programie
   *
   * @param e typ zdarzenia
   */
  void jMenuItem7_actionPerformed(ActionEvent e) {
    About a = new About();
    a.setVisible(true);
  }

}