package javapas;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;

/**
 * <p>Title: Javapas</p>
 * <p>Description: Pascal Interpreter</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: AP</p>
 *
 * <h4>Okno zawierajce pseudokod programu</h4>
 *
 * @author Wojciech Nabiaek
 * @version 1.0
 */

public class Debug extends JFrame {
  private ImageIcon wyjdz = new ImageIcon("src/img/Exit.gif");

  private JPanel jPanel1 = new JPanel();
  private JPanel jPanel2 = new JPanel();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private GridLayout gridLayout1 = new GridLayout();
  private JSplitPane jSplitPane1 = new JSplitPane();
  private JTextArea jTextArea1 = new JTextArea();
  private JTextArea jTextArea2 = new JTextArea();
  private JButton jButton1 = new JButton("Zamknij", wyjdz);

  public Debug() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setSize(new Dimension(400, 300));
    this.setTitle("Pascal interpreter - debug");
    jPanel1.setLayout(gridLayout1);
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    jSplitPane1.setDividerSize(3);
    jTextArea2.setEditable(false);
    jTextArea1.setEditable(false);
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jScrollPane1, null);
    jScrollPane1.getViewport().add(jSplitPane1, null);
    jSplitPane1.add(jTextArea1, JSplitPane.LEFT);
    jSplitPane1.add(jTextArea2, JSplitPane.RIGHT);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(jButton1, null);
    jSplitPane1.setDividerLocation(40);
    if (jButton1.getIcon().getIconHeight()==-1){
      try{
        jButton1.setIcon(new ImageIcon(Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("/img/Fileopen.gif"))));
      } catch (Exception e){}
    }
  }

  /**
   * Metoda wywietla w oknie pseudokod programu wraz z numeracja wierszy
   *
   * @param dane pseudokod programu
   */
  public void setText(Vector dane){
    jTextArea1.setText("");
    jTextArea2.setText("");
    for(int i=0; i<dane.size(); i++){
      jTextArea1.append(""+i+")\r\n");
      jTextArea2.append((String)dane.elementAt(i)+"\r\n");
    }
    jTextArea1.setCaretPosition(0);
    jTextArea2.setCaretPosition(0);
  }

  /**
   * Akcja na wcinicie guzika Zamknij
   *
   * @param e typ zdarzenia
   */
  void jButton1_actionPerformed(ActionEvent e) {
    this.setVisible(false);
  }
}