package javapas;

/**
 * <p>Title: Javapas</p>
 * <p>Description: Pascal Interpreter</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: AP</p>
 *
 * <h4>Klasa opisujca zmienn pascalow</h4>
 *
 * @author Wojciech Nabiaek
 * @version 1.0
 */

public class Zmienna {
  /** Nazwa zmiennej */
  private String nazwa;
  /** Warto zmiennej */
  private String wartosc;
  /** Typ zmiennej */
  private String typ;
  /** Bit informacji czy dana zmienna nie jest sta */
  private boolean czyStala;

  /**
   * Konstruktor tworzcy zmienn typu <code>String</code> o nazwie podanej parametrem
   *
   * @param Nazwa nazwa zmiennej
   */
  public Zmienna(String Nazwa) {
    nazwa=Nazwa;
    wartosc="";
    typ="String";
    czyStala=false;
  }

  /**
   * Konstruktor tworzcy sta o podanej nazwie i wartoci.
   *
   * @param Nazwa nawa staej
   * @param Wartosc warto staej
   * @param CzyStala bit <i>'staoci'</i> - powinien by ustawiony na true
   */
  public Zmienna(String Nazwa, String Wartosc, boolean CzyStala) {
    nazwa=Nazwa;
    wartosc=Wartosc;
    typ=dajTyp(Wartosc);
    czyStala=CzyStala;
  }

  /**
   * Konstruktor tworzcy zmienn o podanej nazwie i typie.
   *
   * @param Nazwa znawa zmiennej
   * @param Typ typ zmiennej
   */
  public Zmienna(String Nazwa, String Typ) {
    nazwa=Nazwa;
    wartosc="";
    typ=Typ;
    czyStala=false;
  }

  /**
   * Konstruktor tworzcy zmienn o podanej nazwie, wartoci i typie
   *
   * @param Nazwa nazwa zmiennej
   * @param Wartosc warto zmiennej
   * @param Typ typ zmiennej
   */
  public Zmienna(String Nazwa, String Wartosc, String Typ){
          nazwa=Nazwa;
          wartosc=Wartosc;
          typ=Typ;
          czyStala=false;
  }

  /**
   * Metoda zwracajca warto zmiennej.
   *
   * @return warto zmiennej
   */
  public String dajWartosc(){
    return wartosc;
  }

  /**
   * Metoda zwracajca nazw zmiennej.
   *
   * @return nazwa zmiennej
   */
  public String dajNazwe(){
    return nazwa;
  }

  /**
   * Metoda zwracajca typ zmiennej.
   *
   * @return typ zmiennej
   */
  public String dajTyp(){
    return typ;
  }

  /**
   * Metoda ustawiajca warto zmiennej
   *
   * @param Wartosc warto zmiennej
   */
  public void ustawWartosc(String Wartosc){
    wartosc=Wartosc;
  }

  /**
   * Metoda na podstawie wartoci zmiennej podanej w parametrze okrela typ tej zmiennej
   *
   * @param wartosc warto zmiennej
   * @return typ zmiennej
   */
  private String dajTyp(String wartosc){
    String wy = "String";
    if (wartosc.equalsIgnoreCase("true") || wartosc.equalsIgnoreCase("false") ) wy="Boolean";
    try {
      if (Integer.valueOf(wartosc).toString().equalsIgnoreCase(wartosc)) wy="Integer";
    } catch (java.lang.NumberFormatException e){};
    try {
      if (Double.valueOf(wartosc).toString().equalsIgnoreCase(wartosc)) wy="Real";
    } catch (java.lang.NumberFormatException e){};
    return wy;
  }

  /**
   * Konwersja klasy do acucha znakw
   *
   * @return acuch znakw opisujcy zawarto klasy
   */
  public String toString(){
    String wy = nazwa+"="+wartosc+" : "+typ;
    if(czyStala) return "const " + wy;
    else return "var" + wy;
  }
}